CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  'input pin list

  DMXPin = 16
  
  arcade1 = 19
  arcade2 = 18
  arcade3 = 17

  knob1Button = 15
  knob1R = 14
  knob1L = 13

  knob2Button = 11
  knob2R = 12
  knob2L = 10
  
  knob3Button = 7
  knob3R = 9
  knob3L = 8


OBJ
      
  'Comm : "SerialMirror"
  Comm : "Extended_FDSerial"
  NUM  : "Numbers"
  STR    : "STRINGS"
  DMXout : "DMXout"

VAR
  long x[64]
  byte command
  byte channelStr[3]
  byte channel
  byte channelValueStr[3]
  byte channelValue

  byte button1
  byte button2
  byte button3
  byte button4
  byte button5
  byte button6

  byte button1State
  byte button2State
  byte button3State
  byte button4State
  byte button5State
  byte button6State

  byte button1Change
  byte button2Change
  byte button3Change
  byte button4Change
  byte button5Change
  byte button6Change

  byte knob1PrevStep
  byte knob2PrevStep
  byte knob3PrevStep

  byte currKnobStep

  byte recNum
  
  'long BtnScanStack[50]
  'byte cogBtnScan

  byte counter
  long recByte
  long prevByte
         
PUB Main

 {{
   -------------------------------
   Assumes 4 Bytes are sent in this fasion:
   Channel [1-255] - Value [0-255] - $00 - Command
   3 data bytes and 1 framing byte. Insure that Channel is not 0.
 }} 

  button1 := 0
  button2 := 0
  button3 := 0
  button4 := 0
  button5 := 0
  button6 := 0
  
  button1State := 0
  button2State := 0
  button3State := 0
  button4State := 0
  button5State := 0
  button6State := 0
  
  button1Change := 0
  button2Change := 0
  button3Change := 0
  button4Change := 0
  button5Change := 0
  button6Change := 0
  
 
  Comm.start(31,30, 0, 56000)

  DMXout.Start(DMXPin)

  NUM.Init

  counter := 0
  prevByte := $ff
  
  repeat

     recByte := Comm.rxCheck

     if(recByte <> -1)  {{=============received a byte}}


          x[counter] := recByte
          counter := counter + 1
     
           'Comm.str(STR.Combine(Num.ToStr(recByte,NUM#DEC),string(" (nothing)",10)))
           if(prevByte == $00 AND recByte == $01)
              counter := 0
             'Comm.str(STR.Combine(Num.ToStr(x[0],NUM#DEC),string(" (channel)",13)))
             'Comm.str(STR.Combine(Num.ToStr(x[1],NUM#DEC),string(" (value)",10)))
               DMXout.Write(x[0],x[1])
              Comm.str(STR.Combine(Num.ToStr(x[0],NUM#DEC),string(":",9)))
              Comm.str(STR.Combine(Num.ToStr(x[1],NUM#DEC),string(" ",13)))
              'prevByte := $ff





           prevByte := recByte 
    
           
     'else      '========timeout
           'Comm.str(STR.Combine(Num.ToStr(recByte,NUM#DEC),string(" (nothing)",10)))
           'Comm.str(string("ready",10))
           'prevByte := -1
           'waitcnt(cnt+80_000_000)

    scanButtons
     
                  if (button1State <> button1)
                      if(button1 == 1)
                        Comm.str(string("9,1,1",10))
                      else
                        Comm.str(string("9,1,0",10))
                      button1State := button1  
                        
                  if (button2State <> button2)
                      if(button2 == 1)
                        Comm.str(string("9,2,1",10))
                      else
                        Comm.str(string("9,2,0",10))
                      button2State := button2
                      
                  if (button3State <> button3)
                      if(button3 == 1)
                        Comm.str(string("9,3,1",10))
                      else
                        Comm.str(string("9,3,0",10))
                      button3State := button3
                   
                  if (button4State <> button4)
                      if(button4 == 1)
                        Comm.str(string("9,4,1",10))
                      else
                        Comm.str(string("9,4,0",10))
                      button4State := button4  
                        
                  if (button5State <> button5)
                      if(button5 == 1)
                        Comm.str(string("9,5,1",10))
                      else
                        Comm.str(string("9,5,0",10))
                      button5State := button5
                      
                  if (button6State <> button6)
                      if(button6 == 1)
                        Comm.str(string("9,6,1",10))
                      else
                        Comm.str(string("9,6,0",10))
                      button6State := button6

       
             
PRI AppendChar( dstStrPtr, char )
  dstStrPtr += StrSize(dstStrPtr)
  byte[ dstStrPtr++ ] := char
  byte[ dstStrPtr   ] := 0

PUB scanButtons

    if INA[arcade1] == 0 AND button1Change < 25
      button1Change := button1Change + 1
    elseif INA[arcade1] == 1 AND button1Change > 0
      button1Change := button1Change - 1

    if INA[arcade2] == 0 AND button2Change < 25
      button2Change := button2Change + 1
    elseif INA[arcade2] == 1 AND button2Change > 0
      button2Change := button2Change - 1

    if INA[arcade3] == 0 AND button3Change < 25
      button3Change := button3Change + 1
    elseif INA[arcade3] == 1 AND button3Change > 0
      button3Change := button3Change - 1

    if INA[knob1Button] == 0 AND button4Change < 25
      button4Change := button4Change + 1
    elseif INA[knob1Button] == 1 AND button4Change > 0
      button4Change := button4Change - 1

    if INA[knob2Button] == 0 AND button5Change < 25
      button5Change := button5Change + 1
    elseif INA[knob2Button] == 1 AND button5Change > 0
      button5Change := button5Change - 1

    if INA[knob3Button] == 0 AND button6Change < 25
      button6Change := button6Change + 1
    elseif INA[knob3Button] == 1 AND button6Change > 0
      button6Change := button6Change - 1


    if button1Change => 15
      button1 := 1
    if button1Change == 0
      button1 := 0
      
    if button2Change => 15
      button2 := 1
    if button2Change == 0
      button2 := 0

    if button3Change => 15
      button3 := 1
    if button3Change == 0
      button3 := 0

    if button4Change => 15
      button4 := 1
    if button4Change == 0
      button4 := 0
      
    if button5Change => 15
      button5 := 1
    if button5Change == 0
      button5 := 0

    if button6Change => 15
      button6 := 1
    if button6Change == 0
      button6 := 0

{{---------- KNOBS:-------------}}
{{
    8,4,1
    8 - designates input; 8:knob/rotary encoder
    4 - designates the knob number
    1 - designates state; 0:clkwise, 1: cntrclkwise
}}

    currKnobStep := 2*INA[knob1L] + INA[knob1R]

    if(knob1PrevStep == 1 AND currKnobStep == 0)
      Comm.str(string("8,1,0",10))
    if (knob1PrevStep == 2 AND currKnobStep == 0)
      Comm.str(string("8,1,1",10))
    knob1PrevStep :=  currKnobStep
    

    currKnobStep := 2*INA[knob2L] + INA[knob2R]

    if(knob2PrevStep == 1 AND currKnobStep == 0)
      Comm.str(string("8,2,0",10))
    if (knob2PrevStep == 2 AND currKnobStep == 0)
      Comm.str(string("8,2,1",10))
    knob2PrevStep :=  currKnobStep


    currKnobStep := 2*INA[knob3L] + INA[knob3R]

    if(knob3PrevStep == 1 AND currKnobStep == 0)
      Comm.str(string("8,3,0",10))
    if (knob3PrevStep == 2 AND currKnobStep == 0)
      Comm.str(string("8,3,1",10))
    knob3PrevStep :=  currKnobStep

DAT

testStr byte "1234123",0    